#line 980 "../../src/builtin/snarf.m4"
/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 980
#ifdef HAVE_CONFIG_H
#line 980
# include <config.h>
#line 980
#endif
#line 980
#include <sys/types.h>
#line 980

#line 980
#include "mailfromd.h"
#line 980
#include "prog.h"
#line 980
#include "builtin.h"
#line 980

#line 980

#line 1020 "../../src/builtin/snarf.m4"

/* End of snarf.m4 */
#line 1 "dns.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2020 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <limits.h>
#include "srvcfg.h"
#include "global.h"

void
#line 27
bi_primitive_hostname(eval_environ_t env)
#line 27

#line 27

#line 27 "dns.bi"
{
#line 27
	
#line 27

#line 27

#line 27
char * MFL_DATASEG string;
#line 27
        
#line 27
get_string_arg(env, 0, &string);
#line 27
        
#line 27

#line 27
        adjust_stack(env, 1);
#line 27

#line 27

#line 27
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 27
		prog_trace(env, "primitive_hostname %s",string);;
#line 27

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 33
		(
#line 33
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("cannot resolve IP %s"),string)
#line 33
)
#line 36
;
	
	pushs(env, hbuf);
	free(hbuf);
}

#line 41
        env_function_cleanup_flush(env, NULL);
#line 41
	return;
#line 41
}

void
#line 43
bi_primitive_resolve(eval_environ_t env)
#line 43

#line 43

#line 43 "dns.bi"
{
#line 43
	
#line 43

#line 43
long __bi_argcnt;
#line 43
char * MFL_DATASEG string;
#line 43
        char * MFL_DATASEG domain;
#line 43
        
#line 43
get_string_arg(env, 1, &string);
#line 43
        get_string_arg(env, 2, &domain);
#line 43
        
#line 43
get_numeric_arg(env, 0, &__bi_argcnt);
#line 43
        adjust_stack(env, __bi_argcnt + 1);
#line 43

#line 43

#line 43
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 43
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 43

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 50
		(
#line 50
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s.%s"),string,domain)
#line 50
)
#line 52
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 55
		(
#line 55
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s"),string)
#line 55
)
#line 57
;
	}
	pushs(env, ipstr);
	free(ipstr);
}

#line 62
        env_function_cleanup_flush(env, NULL);
#line 62
	return;
#line 62
}

void
#line 64
bi_primitive_hasmx(eval_environ_t env)
#line 64

#line 64

#line 64 "dns.bi"
{
#line 64
	
#line 64

#line 64

#line 64
char *  string;
#line 64
        
#line 64
get_string_arg(env, 0, &string);
#line 64
        
#line 64

#line 64
        adjust_stack(env, 1);
#line 64

#line 64

#line 64
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 64
		prog_trace(env, "primitive_hasmx %s",string);;
#line 64

{
	struct dns_reply repl;
	mf_status mxstat;

	mxstat = dns_to_mf_status(mx_lookup(string, 0, &repl));
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 71
		(
#line 71
	env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("cannot get MX records for %s"),string)
#line 71
)
#line 74
;
	dns_reply_free(&repl);
	if (mxstat == mf_success) {
		
#line 77
do {
#line 77
  push(env, (STKVAL)(mft_number)(1));
#line 77
  goto endlab;
#line 77
} while (0);
	}
	
#line 79
do {
#line 79
  push(env, (STKVAL)(mft_number)(0));
#line 79
  goto endlab;
#line 79
} while (0);
}
endlab:
#line 81
        env_function_cleanup_flush(env, NULL);
#line 81
	return;
#line 81
}

void
#line 83
bi_getmx(eval_environ_t env)
#line 83

#line 83

#line 83 "dns.bi"
{
#line 83
	
#line 83

#line 83
long __bi_argcnt;
#line 83
char * MFL_DATASEG domain;
#line 83
        long  resolve;
#line 83
        
#line 83
get_string_arg(env, 1, &domain);
#line 83
        get_numeric_arg(env, 2, &resolve);
#line 83
        
#line 83
get_numeric_arg(env, 0, &__bi_argcnt);
#line 83
        adjust_stack(env, __bi_argcnt + 1);
#line 83

#line 83

#line 83
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 83
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? resolve : 0));;
#line 83

{
	mf_status mxstat;
	struct dns_reply reply;
	int i;
	
	mxstat = dns_to_mf_status(mx_lookup(domain, ((__bi_argcnt > 1) ? resolve : 0),
					    &reply));
	if (!mf_resolved(mxstat)) {
		(
#line 92
	env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain)
#line 92
);
#line 94
	}
	if (mxstat == mf_not_found) {
		
#line 96
do {
#line 96
  pushs(env, "");
#line 96
  goto endlab;
#line 96
} while (0);
	} else if (reply.type == dns_reply_ip) {
		heap_obstack_begin(env);
		for (i = 0; i < reply.count; i++) {
			struct in_addr s;
			s.s_addr = reply.data.ip[i];
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 104
do {
#line 104
  char *__s = inet_ntoa(s);
#line 104
  heap_obstack_grow(env, __s, strlen(__s));
#line 104
} while (0);
		}
	} else {
		heap_obstack_begin(env);
		for (i = 0; i < reply.count; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 111
do {
#line 111
  char *__s = reply.data.str[i];
#line 111
  heap_obstack_grow(env, __s, strlen(__s));
#line 111
} while (0);
		}
	}
	do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
	dns_reply_free(&reply);
	
#line 116
do {
#line 116
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 116
  goto endlab;
#line 116
} while (0);
}
endlab:
#line 118
        env_function_cleanup_flush(env, NULL);
#line 118
	return;
#line 118
}

static dns_status
resolve_host(const char *string, struct dns_reply *reply)
{
	struct in_addr addr;

	if (inet_aton(string, &addr)) {
		dns_reply_init(reply, dns_reply_ip, 1);
		reply->data.ip[0] = addr.s_addr;
		return dns_success;
	}
	return a_lookup(string, reply);
}

static int
dns_replies_intersect(struct dns_reply const *a, struct dns_reply const *b)
{
	int i, j;
	
	if (a->type == b->type && a->type == dns_reply_ip) {
		for (i = 0; i < a->count; i++) 
			for (j = 0; j < b->count; j++) 
				if (a->data.ip[i] == b->data.ip[j])
					return 1;
	}
	return 0;
}

void
#line 147
bi_primitive_ismx(eval_environ_t env)
#line 147

#line 147

#line 147 "dns.bi"
{
#line 147
	
#line 147

#line 147

#line 147
char *  domain;
#line 147
        char *  ipstr;
#line 147
        
#line 147
get_string_arg(env, 0, &domain);
#line 147
        get_string_arg(env, 1, &ipstr);
#line 147
        
#line 147

#line 147
        adjust_stack(env, 2);
#line 147

#line 147

#line 147
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 147
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 147

{
	struct dns_reply areply, mxreply;
	dns_status status;
	int rc = 0;

	status = resolve_host(ipstr, &areply);
		if (!(status == dns_success))
#line 154
		(
#line 154
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(status)), "primitive_ismx", _("cannot resolve host name %s"),ipstr)
#line 154
)
#line 156
;
	status = mx_lookup(domain, 1, &mxreply);
	if (status != dns_success) {
		dns_reply_free(&areply);
		(
#line 160
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(status)), "primitive_ismx", _("cannot get MXs for %s"),domain)
#line 160
);
#line 162
	}
	rc = dns_replies_intersect(&areply, &mxreply);
	dns_reply_free(&areply);
	dns_reply_free(&mxreply);
	
#line 166
do {
#line 166
  push(env, (STKVAL)(mft_number)(rc));
#line 166
  goto endlab;
#line 166
} while (0);
}
endlab:
#line 168
        env_function_cleanup_flush(env, NULL);
#line 168
	return;
#line 168
}

void
#line 170
bi_relayed(eval_environ_t env)
#line 170

#line 170

#line 170 "dns.bi"
{
#line 170
	
#line 170

#line 170

#line 170
char *  s;
#line 170
        
#line 170
get_string_arg(env, 0, &s);
#line 170
        
#line 170

#line 170
        adjust_stack(env, 1);
#line 170

#line 170

#line 170
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 170
		prog_trace(env, "relayed %s",s);;
#line 170

{
	
#line 172
do {
#line 172
  push(env, (STKVAL)(mft_number)(relayed_domain_p(s)));
#line 172
  goto endlab;
#line 172
} while (0);
}
endlab:
#line 174
        env_function_cleanup_flush(env, NULL);
#line 174
	return;
#line 174
}

void
#line 176
bi_ptr_validate(eval_environ_t env)
#line 176

#line 176

#line 176 "dns.bi"
{
#line 176
	
#line 176

#line 176

#line 176
char *  s;
#line 176
        
#line 176
get_string_arg(env, 0, &s);
#line 176
        
#line 176

#line 176
        adjust_stack(env, 1);
#line 176

#line 176

#line 176
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 176
		prog_trace(env, "ptr_validate %s",s);;
#line 176

{
	int rc, res;
	switch (rc = ptr_validate(s, NULL)) {
	case dns_success:
		res = 1;
		break;
	case dns_not_found:
		res = 0;
		break;
	default:
		(
#line 187
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(rc)), "ptr_validate", _("failed to get PTR record for %s"),s)
#line 187
);
#line 189
	}
	
#line 190
do {
#line 190
  push(env, (STKVAL)(mft_number)(res));
#line 190
  goto endlab;
#line 190
} while (0);
}
endlab:
#line 192
        env_function_cleanup_flush(env, NULL);
#line 192
	return;
#line 192
}

void
#line 194
bi_primitive_hasns(eval_environ_t env)
#line 194

#line 194

#line 194 "dns.bi"
{
#line 194
	
#line 194

#line 194

#line 194
char *  dom;
#line 194
        
#line 194
get_string_arg(env, 0, &dom);
#line 194
        
#line 194

#line 194
        adjust_stack(env, 1);
#line 194

#line 194

#line 194
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 194
		prog_trace(env, "primitive_hasns %s",dom);;
#line 194

{
	struct dns_reply repl;
	mf_status stat = dns_to_mf_status(ns_lookup(dom, 0, &repl));
		if (!(stat == mf_success || stat == mf_not_found))
#line 198
		(
#line 198
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_hasns", _("cannot get NS records for %s"),dom)
#line 198
)
#line 201
;
	dns_reply_free(&repl);
	if (stat == mf_success) {
		
#line 204
do {
#line 204
  push(env, (STKVAL)(mft_number)(1));
#line 204
  goto endlab;
#line 204
} while (0);
	}
	
#line 206
do {
#line 206
  push(env, (STKVAL)(mft_number)(0));
#line 206
  goto endlab;
#line 206
} while (0);
}
endlab:
#line 208
        env_function_cleanup_flush(env, NULL);
#line 208
	return;
#line 208
}

static int
cmp_ip(void const *a, void const *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T const *)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T const *)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

static int
cmp_str(void const *a, void const *b)
{
	char * const *stra = a;
	char * const *strb = b;
	return strcmp(*stra, *strb);
}

void
#line 230
bi_getns(eval_environ_t env)
#line 230

#line 230

#line 230 "dns.bi"
{
#line 230
	
#line 230

#line 230
long __bi_argcnt;
#line 230
char * MFL_DATASEG domain;
#line 230
        long  resolve;
#line 230
        long  sort;
#line 230
        
#line 230
get_string_arg(env, 1, &domain);
#line 230
        get_numeric_arg(env, 2, &resolve);
#line 230
        get_numeric_arg(env, 3, &sort);
#line 230
        
#line 230
get_numeric_arg(env, 0, &__bi_argcnt);
#line 230
        adjust_stack(env, __bi_argcnt + 1);
#line 230

#line 230

#line 230
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 230
		prog_trace(env, "getns %s %lu %lu",domain, ((__bi_argcnt > 1) ? resolve : 0), ((__bi_argcnt > 2) ? sort : 0));;
#line 230

{
	mf_status stat;
	struct dns_reply reply;
	int i;
	
	stat = dns_to_mf_status(ns_lookup(domain, ((__bi_argcnt > 1) ? resolve : 0),
					  &reply));
	if (!mf_resolved(stat)) {
		(
#line 239
	env_throw_bi(env, mf_status_to_exception(stat), "getns", _("cannot get MX records for %s"),domain)
#line 239
);
#line 241
	}
	if (stat == mf_not_found) {
		
#line 243
do {
#line 243
  pushs(env, "");
#line 243
  goto endlab;
#line 243
} while (0);
	}

	heap_obstack_begin(env);
	if (reply.type == dns_reply_ip) {
		if (sort)
			qsort(reply.data.ip,
			      reply.count,
			      sizeof(reply.data.ip[0]),
			      cmp_ip);
		for (i = 0; i < reply.count; i++) {
			struct in_addr s;
			s.s_addr = reply.data.ip[i];
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 258
do {
#line 258
  char *__s = inet_ntoa(s);
#line 258
  heap_obstack_grow(env, __s, strlen(__s));
#line 258
} while (0);
		}
	} else {
		if (sort)
			qsort(reply.data.str,
			      reply.count,
			      sizeof(reply.data.str[0]),
			      cmp_str);
		for (i = 0; i < reply.count; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 269
do {
#line 269
  char *__s = reply.data.str[i];
#line 269
  heap_obstack_grow(env, __s, strlen(__s));
#line 269
} while (0);
		}
	}
	do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
	dns_reply_free(&reply);
	
#line 274
do {
#line 274
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 274
  goto endlab;
#line 274
} while (0);
}
endlab:
#line 276
        env_function_cleanup_flush(env, NULL);
#line 276
	return;
#line 276
}

typedef long DNS_REPLY_COUNT;
#define DNS_REPLY_MAX LONG_MAX

struct dns_reply_storage {
	DNS_REPLY_COUNT reply_count;
	size_t reply_max;
	struct dns_reply *reply_tab;
};

static inline int
dns_reply_entry_unused(struct dns_reply_storage *rs, DNS_REPLY_COUNT n)
{
	return rs->reply_tab[n].type == -1;
}

static inline void
dns_reply_entry_release(struct dns_reply_storage *rs, DNS_REPLY_COUNT n)
{
	rs->reply_tab[n].type = -1;
}

static inline struct dns_reply *
dns_reply_entry_locate(struct dns_reply_storage *rs, DNS_REPLY_COUNT n)
{
	if (n < 0 || n >= rs->reply_count || dns_reply_entry_unused(rs, n))
		return NULL;
	return &rs->reply_tab[n];
}

static void *
dns_reply_storage_alloc(void)
{
	struct dns_reply_storage *rs = mu_alloc(sizeof(*rs));
	rs->reply_count = 0;
	rs->reply_max = 0;
	rs->reply_tab = NULL;
	return rs;
}

static void
dns_reply_storage_destroy(void *data)
{
	struct dns_reply_storage *rs = data;
	DNS_REPLY_COUNT i;

	for (i = 0; i < rs->reply_count; i++) {
		if (!dns_reply_entry_unused(rs, i)) {
			dns_reply_free(&rs->reply_tab[i]);
			dns_reply_entry_release(rs, i);
		}
	}
	free(rs->reply_tab);
	free(rs);
}


#line 333

#line 333
static int DNS_id;
#line 333 "dns.bi"


static inline DNS_REPLY_COUNT
dns_reply_entry_alloc(struct dns_reply_storage *rs,
		      struct dns_reply **return_reply)
{
	DNS_REPLY_COUNT i;
	
	for (i = 0; i < rs->reply_count; i++) {
		if (dns_reply_entry_unused(rs, i)) {
			*return_reply = &rs->reply_tab[i];
			return i;
		}
	}
	if (rs->reply_count == DNS_REPLY_MAX)
		return -1;
	if (rs->reply_count == rs->reply_max) {
		size_t n = rs->reply_max;
		rs->reply_tab = mu_2nrealloc(rs->reply_tab, &rs->reply_max,
					     sizeof(rs->reply_tab[0]));
		for (; n < rs->reply_max; n++)
			dns_reply_entry_release(rs, n);
	}
	*return_reply = &rs->reply_tab[rs->reply_count];
	return rs->reply_count++;
}

void
#line 360
bi_dns_reply_release(eval_environ_t env)
#line 360

#line 360

#line 360 "dns.bi"
{
#line 360
	
#line 360

#line 360

#line 360
long  n;
#line 360
        
#line 360
get_numeric_arg(env, 0, &n);
#line 360
        
#line 360

#line 360
        adjust_stack(env, 1);
#line 360

#line 360

#line 360
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 360
		prog_trace(env, "dns_reply_release %lu",n);;
#line 360

{
	struct dns_reply_storage *repl = env_get_builtin_priv(env,DNS_id);
	if (!dns_reply_entry_unused(repl, n)) {
		dns_reply_free(&repl->reply_tab[n]);
		dns_reply_entry_release(repl, n);
	}
}

#line 368
        env_function_cleanup_flush(env, NULL);
#line 368
	return;
#line 368
}

void
#line 370
bi_dns_reply_count(eval_environ_t env)
#line 370

#line 370

#line 370 "dns.bi"
{
#line 370
	
#line 370

#line 370

#line 370
long  n;
#line 370
        
#line 370
get_numeric_arg(env, 0, &n);
#line 370
        
#line 370

#line 370
        adjust_stack(env, 1);
#line 370

#line 370

#line 370
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 370
		prog_trace(env, "dns_reply_count %lu",n);;
#line 370

{
	struct dns_reply_storage *rs = env_get_builtin_priv(env,DNS_id);
	struct dns_reply *reply;
	
	if (n == -1)
		
#line 376
do {
#line 376
  push(env, (STKVAL)(mft_number)(0));
#line 376
  goto endlab;
#line 376
} while (0);
	if (n < 0)
		(
#line 378
	env_throw_bi(env, mfe_failure, "dns_reply_count", _("invalid DNS reply number: %ld"),n)
#line 378
);
#line 380
	reply = dns_reply_entry_locate(rs, n);
	if (!reply)
		(
#line 382
	env_throw_bi(env, mfe_failure, "dns_reply_count", _("no such reply: %ld"),n)
#line 382
);
#line 384
	
#line 384
do {
#line 384
  push(env, (STKVAL)(mft_number)(reply->count));
#line 384
  goto endlab;
#line 384
} while (0);
}
endlab:
#line 386
        env_function_cleanup_flush(env, NULL);
#line 386
	return;
#line 386
}

void
#line 388
bi_dns_reply_string(eval_environ_t env)
#line 388

#line 388

#line 388 "dns.bi"
{
#line 388
	
#line 388

#line 388

#line 388
long  n;
#line 388
        long  i;
#line 388
        
#line 388
get_numeric_arg(env, 0, &n);
#line 388
        get_numeric_arg(env, 1, &i);
#line 388
        
#line 388

#line 388
        adjust_stack(env, 2);
#line 388

#line 388

#line 388
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 388
		prog_trace(env, "dns_reply_string %lu %lu",n, i);;
#line 388

{
	struct dns_reply_storage *rs = env_get_builtin_priv(env,DNS_id);
	struct dns_reply *reply = dns_reply_entry_locate(rs, n);
	if (!reply)
		(
#line 393
	env_throw_bi(env, mfe_failure, "dns_reply_string", _("no such reply: %ld"),n)
#line 393
);
#line 395
	if (i < 0 || i >= reply->count)
		(
#line 396
	env_throw_bi(env, mfe_range, "dns_reply_string", _("index out of range: %ld"),i)
#line 396
);
#line 398
	if (reply->type == dns_reply_ip) {
		struct in_addr addr;
		addr.s_addr = reply->data.ip[i];
		
#line 401
do {
#line 401
  pushs(env, inet_ntoa(addr));
#line 401
  goto endlab;
#line 401
} while (0);
	}
	
#line 403
do {
#line 403
  pushs(env, reply->data.str[i]);
#line 403
  goto endlab;
#line 403
} while (0);
}
endlab:
#line 405
        env_function_cleanup_flush(env, NULL);
#line 405
	return;
#line 405
}

void
#line 407
bi_dns_reply_ip(eval_environ_t env)
#line 407

#line 407

#line 407 "dns.bi"
{
#line 407
	
#line 407

#line 407

#line 407
long  n;
#line 407
        long  i;
#line 407
        
#line 407
get_numeric_arg(env, 0, &n);
#line 407
        get_numeric_arg(env, 1, &i);
#line 407
        
#line 407

#line 407
        adjust_stack(env, 2);
#line 407

#line 407

#line 407
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 407
		prog_trace(env, "dns_reply_ip %lu %lu",n, i);;
#line 407

{
	struct dns_reply_storage *rs = env_get_builtin_priv(env,DNS_id);
	struct dns_reply *reply = dns_reply_entry_locate(rs, n);
	if (!reply)
		(
#line 412
	env_throw_bi(env, mfe_failure, "dns_reply_ip", _("no such reply: %ld"),n)
#line 412
);
#line 414
	if (i < 0 || i >= reply->count)
		(
#line 415
	env_throw_bi(env, mfe_range, "dns_reply_ip", _("index out of range: %ld"),i)
#line 415
);
#line 417
	if (reply->type == dns_reply_str) {
		(
#line 418
	env_throw_bi(env, mfe_failure, "dns_reply_ip", _("can't use dns_reply_ip on string replies"))
#line 418
);
#line 420
	}
	
#line 421
do {
#line 421
  pushs(env, reply->data.str[i]);
#line 421
  goto endlab;
#line 421
} while (0);
}
endlab:
#line 423
        env_function_cleanup_flush(env, NULL);
#line 423
	return;
#line 423
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcasecmp(*(const char**) a, *(const char**) b);
}

enum {
	DNS_TYPE_A = 1,
	DNS_TYPE_NS = 2,
	DNS_TYPE_PTR = 12,	
	DNS_TYPE_MX = 15,
	DNS_TYPE_TXT = 16,
};

static char *dns_type_name[] = {
	[DNS_TYPE_A] = "a",
	[DNS_TYPE_NS] = "ns",
	[DNS_TYPE_PTR] = "ptr",	
	[DNS_TYPE_MX] = "mx",
	[DNS_TYPE_TXT] = "txt"
};

void
#line 459
bi_dns_query(eval_environ_t env)
#line 459

#line 459

#line 459 "dns.bi"
{
#line 459
	
#line 459

#line 459
long __bi_argcnt;
#line 459
long  type;
#line 459
        char *  domain;
#line 459
        long  sort;
#line 459
        long  resolve;
#line 459
        
#line 459
get_numeric_arg(env, 1, &type);
#line 459
        get_string_arg(env, 2, &domain);
#line 459
        get_numeric_arg(env, 3, &sort);
#line 459
        get_numeric_arg(env, 4, &resolve);
#line 459
        
#line 459
get_numeric_arg(env, 0, &__bi_argcnt);
#line 459
        adjust_stack(env, __bi_argcnt + 1);
#line 459

#line 459

#line 459
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 459
		prog_trace(env, "dns_query %lu %s %lu %lu",type, domain, ((__bi_argcnt > 2) ? sort : 0), ((__bi_argcnt > 3) ? resolve : 0));;

{
	struct dns_reply_storage *rs = env_get_builtin_priv(env,DNS_id);
	dns_status dnsstat;
	mf_status stat;
	DNS_REPLY_COUNT ret;
	struct dns_reply *reply;
	int (*cmpfun)(const void *, const void *) = NULL;
	struct in_addr addr;
	
	ret = dns_reply_entry_alloc(rs, &reply);
		if (!(ret >= 0))
#line 471
		(
#line 471
	env_throw_bi(env, mfe_failure, "dns_query", _("DNS reply table full"))
#line 471
)
#line 473
;
	
	switch (type) {
	case DNS_TYPE_PTR:
			if (!(inet_aton(domain, &addr)))
#line 477
		(
#line 477
	env_throw_bi(env, mfe_invip, "dns_query", _("invalid IP: %s"),domain)
#line 477
)
#line 479
;
		dnsstat = ptr_lookup(addr, reply);
		cmpfun = hostname_cmp;
		break;
		
	case DNS_TYPE_A:
		dnsstat = resolve_host(domain, reply);
		break;
		
	case DNS_TYPE_TXT:
		dnsstat = txt_lookup(domain, reply);
		break;
		
	case DNS_TYPE_MX:
		dnsstat = mx_lookup(domain, ((__bi_argcnt > 3) ? resolve : 0), reply);
		break;
		
	case DNS_TYPE_NS:
		dnsstat = ns_lookup(domain, ((__bi_argcnt > 3) ? resolve : 0), reply);
		break;

	default:
		dns_reply_entry_release(rs, ret);		
		(
#line 502
	env_throw_bi(env, mfe_failure, "dns_query", _("unsupported type: %ld"),type)
#line 502
);
#line 504
	}
	
	stat = dns_to_mf_status(dnsstat);

	if (!mf_resolved(stat)) {
		dns_reply_entry_release(rs, ret);
		(
#line 510
	env_throw_bi(env, mf_status_to_exception(stat), "dns_query", _("cannot get %s records for %s"),dns_type_name[type],domain)
#line 510
);
#line 513
	}
	if (stat == mf_not_found) {
		dns_reply_entry_release(rs, ret);
		
#line 516
do {
#line 516
  push(env, (STKVAL)(mft_number)(-1));
#line 516
  goto endlab;
#line 516
} while (0);
	}
	if (sort) {
		size_t entry_size;
		
		if (!cmpfun) {
			if (reply->type == dns_reply_str) {
				cmpfun = cmp_str;
			} else {
				cmpfun = cmp_ip;
			}
		}
		if (reply->type == dns_reply_str) {
			entry_size = sizeof(reply->data.str[0]);
		} else {
			entry_size = sizeof(reply->data.ip[0]);
		}
		
		qsort(reply->data.ptr, reply->count, entry_size, cmpfun);
	}
	
#line 536
do {
#line 536
  push(env, (STKVAL)(mft_number)(ret));
#line 536
  goto endlab;
#line 536
} while (0);
}
endlab:
#line 538
        env_function_cleanup_flush(env, NULL);
#line 538
	return;
#line 538
}

/* Compatibility functions */
void
#line 541
bi_dns_getaddr(eval_environ_t env)
#line 541

#line 541

#line 541 "dns.bi"
{
#line 541
	
#line 541

#line 541

#line 541
char * MFL_DATASEG string;
#line 541
        
#line 541
get_string_arg(env, 0, &string);
#line 541
        
#line 541

#line 541
        adjust_stack(env, 1);
#line 541

#line 541

#line 541
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 541
		prog_trace(env, "dns_getaddr %s",string);;
#line 541

{
	size_t i;
	dns_status dnstat;
	struct dns_reply r;
	
	dnstat = a_lookup(string, &r);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(r.data.ip, r.count, sizeof r.data.ip[0], ipaddr_cmp);
		for (i = 0; i < r.count; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = r.data.ip[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 560
do {
#line 560
  char *__s = q;
#line 560
  heap_obstack_grow(env, __s, strlen(__s));
#line 560
} while (0);
		}
		dns_reply_free(&r);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 564
do {
#line 564
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 564
  goto endlab;
#line 564
} while (0);
	}
	case dns_not_found:
		
#line 567
do {
#line 567
  pushs(env, "");
#line 567
  goto endlab;
#line 567
} while (0);
	default:
		(
#line 569
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(dnstat)), "dns_getaddr", _("failed to get A record for %s"),string)
#line 569
);
#line 571
	}
}
endlab:
#line 573
        env_function_cleanup_flush(env, NULL);
#line 573
	return;
#line 573
}

void
#line 575
bi_dns_getname(eval_environ_t env)
#line 575

#line 575

#line 575 "dns.bi"
{
#line 575
	
#line 575

#line 575

#line 575
char * MFL_DATASEG ipstr;
#line 575
        
#line 575
get_string_arg(env, 0, &ipstr);
#line 575
        
#line 575

#line 575
        adjust_stack(env, 1);
#line 575

#line 575

#line 575
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 575
		prog_trace(env, "dns_getname %s",ipstr);;
#line 575

{
	dns_status dnstat;
	struct in_addr addr;
	struct dns_reply r;
	
		if (!(inet_aton(ipstr, &addr)))
#line 581
		(
#line 581
	env_throw_bi(env, mfe_invip, "dns_getname", _("invalid IP: %s"),ipstr)
#line 581
)
#line 583
;

	dnstat = ptr_lookup(addr, &r);
	switch (dnstat) {
	case dns_success: {
		size_t i;

		qsort(r.data.str, r.count, sizeof r.data.str[0], hostname_cmp);

		heap_obstack_begin(env);
		for (i = 0; i < r.count; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 596
do {
#line 596
  char *__s = (char*)r.data.str[i];
#line 596
  heap_obstack_grow(env, __s, strlen(__s));
#line 596
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		dns_reply_free(&r);
		
#line 601
do {
#line 601
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 601
  goto endlab;
#line 601
} while (0);
	}
	case dns_not_found:
		
#line 604
do {
#line 604
  pushs(env, "");
#line 604
  goto endlab;
#line 604
} while (0);
	default:
		(
#line 606
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(dnstat)), "dns_getname", _("failed to get PTR record for %s"),ipstr)
#line 606
);
#line 608
	}
}
endlab:
#line 610
        env_function_cleanup_flush(env, NULL);
#line 610
	return;
#line 610
}

#line 980 "../../src/builtin/snarf.m4"

#line 980

#line 980

#line 980
void
#line 980
dns_init_builtin(void)
#line 980
{
#line 980
	
#line 980
	#line 27 "dns.bi"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 43 "dns.bi"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_string);
#line 64 "dns.bi"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 83 "dns.bi"
va_builtin_install_ex("getmx", bi_getmx, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_number);
#line 147 "dns.bi"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_string);
#line 170 "dns.bi"
va_builtin_install_ex("relayed", bi_relayed, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 176 "dns.bi"
va_builtin_install_ex("ptr_validate", bi_ptr_validate, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 194 "dns.bi"
va_builtin_install_ex("primitive_hasns", bi_primitive_hasns, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 230 "dns.bi"
va_builtin_install_ex("getns", bi_getns, 0, dtype_string, 3, 2, 0|0, dtype_string, dtype_number, dtype_number);
#line 333 "dns.bi"
DNS_id = builtin_priv_register(dns_reply_storage_alloc, dns_reply_storage_destroy,
#line 333
NULL);
#line 360 "dns.bi"
va_builtin_install_ex("dns_reply_release", bi_dns_reply_release, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 370 "dns.bi"
va_builtin_install_ex("dns_reply_count", bi_dns_reply_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 388 "dns.bi"
va_builtin_install_ex("dns_reply_string", bi_dns_reply_string, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 407 "dns.bi"
va_builtin_install_ex("dns_reply_ip", bi_dns_reply_ip, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 459 "dns.bi"
va_builtin_install_ex("dns_query", bi_dns_query, 0, dtype_number, 4, 2, 0|0, dtype_number, dtype_string, dtype_number, dtype_number);
#line 541 "dns.bi"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 575 "dns.bi"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, dtype_string, 1, 0, 0|0, dtype_string);

#line 980 "../../src/builtin/snarf.m4"
	
#line 980
}
#line 980 "../../src/builtin/snarf.m4"

